#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "nation.h"
#include "sector.h"
#include "land.h"
#include "ship.h"
#include "plane.h"
#include "nuke.h"

int MAX_X = 128, MAX_Y = 128;
static struct s_nation nat;
int capitol_x, capitol_y;
int my_cnum;
Nation nation = &nat;
struct l_landtype landtypes[MAX_LANDTYPES];
struct s_shtype shiptypes[MAX_SHIPTYPES];
struct s_pltype planetypes[MAX_PLANETYPES];
struct s_nuketype nuke_type[MAX_NUKETYPES];
Land landlist;
Ship shiplist;
Plane first_plane;
Stockp spl_head;

#undef OFFSET
#define OFFSET(x,y) 0
struct pchrstr pchr[]  = {
/*       level      cost    nrndx nrdep nlndx   nlmin nllag effic  sname name */
{0,       0,         0,      0,    0,    0,        0,    0,  0,    
	"unused", 0, { 0 }, { 0 }, "", },
{V_SHELL, -1,        3,      0,    0,    NAT_TLEV, 20,  10, 100, 
	"shells", 2, { V_LCM, V_HCM}, { 2, 1 },  "shells", },
{V_GUN,   -1,        30,     0,    0,    NAT_TLEV, 20,  10, 100, 
	"guns", 3, { V_OIL, V_LCM, V_HCM }, { 1, 5, 10 },  "guns",},
{V_PETROL,-1,        1,      0,    0,    NAT_TLEV, 20,  10, 1000,
	"petrol", 1, { V_OIL }, { 1 },  "petrol",},
{V_IRON,  -1,        0,OFFSET(sctstr, sct_min),0,    -1,       0,    0,  100,
	"iron ore", 0, { 0 }, { 0 },  "iron",	},
{V_DUST,  -1,        0,OFFSET(sctstr, sct_gmin),20,  -1,       0,    0,  100,
	"gold dust", 0, { 0 }, { 0 },  "dust",},
{V_BAR,   -1,        10,     0,    0,    -1,       0,    0,  100, 
	"gold bars", 1, { V_DUST }, { 5 }, "bars",},
{V_FOOD,  -1,        0,OFFSET(sctstr, sct_fertil),0, NAT_TLEV, -10,  10, 900,
	"food", 0, { 0 }, { 0 }, "food",},
{V_OIL,   -1,        0,OFFSET(sctstr, sct_oil),10,   NAT_TLEV, -10,  10, 100, 
	"oil", 0, { 0 }, { 0 }, "oil",},
{V_LCM,   -1,        0,      0,    0,    NAT_TLEV, -10,  10, 100,
	"light construction materials", 1, { V_IRON }, { 1 }, "lcm",},
{V_HCM,   -1,        0,      0,    0,    NAT_TLEV, -10,  10, 100,
	"heavy construction materials", 1, { V_IRON }, { 2 },  "hcm", },
{0,       NAT_TLEV, 300,     0,    0,    NAT_ELEV, 5,    10, 100,
      "technological breakthroughs",3,{V_DUST,V_OIL,V_LCM}, {1,5,10}, "tech",},
{0,       NAT_RLEV, 90,     0,    0,    NAT_ELEV, 5,    10, 100,
      "medical discoveries",3,{V_DUST,V_OIL,V_LCM }, { 1, 5, 10 }, "medical",},
{0,       NAT_ELEV,  9,     0,    0,    -1,       0,    0,  100,
	"a class of graduates", 1, { V_LCM }, { 1 },  "edu",},
{0,       NAT_HLEV,  9,     0,    0,    -1,       0,    0,  100,
	"happy strollers", 1, { V_LCM }, { 1 },  "happy",},
{V_RAD, -1,          2,OFFSET(sctstr, sct_uran),35, NAT_TLEV, 40,  10, 100, 
	"radioactive materials", 0, { 0 }, { 0 },  "rad",},
{0,       0,         0,      0,    0,    0,        0,    0,  0,    
	NULL, 0, { 0 }, { 0 }, NULL, },
};

struct ichrstr ichr[I_MAX+2]  = {
/*      mnem vtype     val sell  lbs rg,wh,ur,bnk  name */
	'?', 0,         0,   0,   0, 0, 0, 0, 0, "unused",
	'c', V_CIVIL,   1,   0,   1, 1, 1,10, 1, "civilians",
	'm', V_MILIT,   0,   0,   1, 1, 1, 1, 1, "military",
	's', V_SHELL,   5,   1,   1, 1,10, 1, 1, "shells",
	'g', V_GUN,     60,  1,   10,1,10, 1, 1, "guns",
	'p', V_PETROL,  4,   1,   1, 1,10, 1, 1, "petrol",
	'i', V_IRON,    2,   1,   1, 1,10, 1, 1, "iron ore",
	'd', V_DUST,    20,  1,   5, 1,10, 1, 1, "dust (gold)",
	'b', V_BAR,     280, 1,   50,1, 5, 1, 1, "bars of gold",
	'f', V_FOOD,    0,   1,   1, 1,10, 1, 1, "food",
	'o', V_OIL,     8,   1,   1, 1,10, 1, 1, "oil",
	'l', V_LCM,     2,   1,   1, 1,10, 1, 1, "light products",
	'h', V_HCM,     4,   1,   1, 1,10, 1, 1, "heavy products",
	'u', V_UW,      1,   1,   2, 1, 1, 1, 1, "uncomp. workers", 
	'r', V_RAD,	150, 1,   8, 1,10, 1, 1, "rad. materials",
  	'\0', 0,         0,   0,   0, 0, 0, 0, 0, 0,
};


Ship NrToShip(int nr) { return NULL; }
void MoveLand (Land land, Sector sct) { ;}
void DeletePlaneFromSector (Plane plane) { }
void DeleteShipFromSector (Ship ship) { }
void AddShipToSector (Ship ship, Sector sct) {}
void AddShipToList (Ship ship) {}
void AddLandToList (Land land) {}
void AddLandToSector (Land land, Sector sct) {}
Land NrToLand (int nr) { return NULL; }
void AddPlaneToList (Plane plane) {}
void AddPlaneToSector (Plane plane, Sector sct) {}

Sector nworld[128][128];

Sector World(int x, int y, int type)
{
    Sector sct;
    int ix, iy;
    Sct2 sct2;
    Sct3 sct3;


    if ((x + y) % 2 != 0)
	return (Sector) 0;

    ix = WX (x);
    iy = WY (y) / 2;

    sct = nworld [ix] [iy];
    if (type == S_EXIST)
	return sct;
    if (sct == NULL) {
	sct = (Sector) malloc ((unsigned) sizeof (struct s_sector1));

	bzero ((char *) sct, sizeof (struct s_sector1));
			
	nworld [ix] [iy] = sct;
	set_xcd (sct, EX (x));
	set_ycd (sct, EY (y));
	set_des (sct, ' ');
	DEL_INFO (sct);
	set_owner (sct, UNKNOWN_CNUM);
	/* allocate second part */

	sct2 = (Sct2) malloc ((unsigned) sizeof (struct s_sector2));
	bzero ((char *) sct2, sizeof (struct s_sector2));
	sct-> sct2 = sct2;
	/* allocate third part */

	sct3 = (Sct3) malloc ((unsigned) sizeof (struct s_sector3));
	bzero ((char *) sct3, sizeof (struct s_sector3));
	sct-> sct2-> sct3 = sct3;
	set_nds (sct, ' ');
    }

    return sct;
} 
Plane NrToPlane (int nr) {return NULL; }
Stockp NewStockPile() { return NULL; };

struct  dchrstr dchr[SCT_MAXDEF+2]  =
{
/*mnem pr.    mcst  fl.     pkg ostr dstr  val  bld lcm hcm nam.  */
{ '.', 0,        0, NAVOK,  NPKG,  0,   0,   0, 0,  0,  0,  "sea"},
{ '^', 0,      127, 0,      NPKG,  2,  16,   5, 1,  0,  0,  "mountain"},
{ 's', 0,        0, 0,      NPKG,  0,  99, 127, 0,  0,  0,  "sanctuary"},
{ '\\',0,        0, 0,      NPKG,  0,  99,   0, 0,  0,  0,  "wasteland"},
{ '-', 0,        4, 0,      NPKG,  2,   2,   1, 0,  0,  0,  "wilderness"},
{ 'c', 0,        2, 0,      NPKG,  2,   4,  30, 1,  0,  0,  "capital"},
{ 'u', P_URAN,   2, 0,      NPKG,  2,   3,  15, 1,  0,  0,  "uranium mine"},
{ 'p', P_HLEV,   2, 0,      NPKG,  2,   2,   5, 1,  0,  0,  "park"},
{ 'd', P_GUN,    2, 0,      NPKG,  2,   2,   7, 1,  0,  0,  "defense plant"},
{ 'i', P_SHELL,  2, 0,      NPKG,  2,   2,   6, 1,  0,  0,  "shell industry"},
{ 'm', P_IRON,   2, 0,      NPKG,  2,   3,   5, 1,  0,  0,  "mine"},
{ 'g', P_DUST,   2, 0,      NPKG,  2,   3,   8, 1,  0,  0,  "gold mine"},
{ 'h', 0,        2, NAV_02, NPKG,  2,   2,  12, 1,  0,  0,  "harbor"},
{ 'w', 0,        2, 0,      WPKG,  2,   2,   7, 1,  0,  0,  "warehouse"},
{ '*', 0,        2, 0,      NPKG,  2,   1,  12, 1,  0,  0,  "airfield"},
{ 'a', P_FOOD,   2, 0,      NPKG,  2,   2,   2, 1,  0,  0,  "agribusiness"},
{ 'o', P_OIL,    2, 0,      NPKG,  2,   2,   5, 1,  0,  0,  "oil field"},
{ 'j', P_LCM,    2, 0,      NPKG,  2,   2,   3, 1,  0,  0,  "light manufacturing"},
{ 'k', P_HCM,    2, 0,      NPKG,  2,   2,   4, 1,  0,  0,  "heavy manufacturing"},
{ 'f', 0,        2, 0,      NPKG,  4,   8,  10, 1,  0,  0,  "fortress"},
{ 't', P_TLEV,   2, 0,      NPKG,  2,   2,  10, 1,  0,  0,  "technical center"},
{ 'r', P_RLEV,   2, 0,      NPKG,  2,   2,   9, 1,  0,  0,  "research lab"},
{ 'n', 0,        2, 0,      NPKG,  2,   3,  10, 1,  0,  0,  "nuclear plant"},
{ 'l', P_ELEV,   2, 0,      NPKG,  2,   2,   4, 1,  0,  0,  "library/school"},
{ '+', 0,        1, 0,      NPKG,  1,   1,   3, 1,  0,  0,  "highway"},
{ ')', 0,        2, 0,      NPKG,  2,   2,   4, 1,  0,  0,  "radar installation"},
{ '!', 0,        2, 0,      NPKG,  2,   2,   1, 1,  0,  0,  "headquarters"},
{ '#', 0,        2, 0,      NPKG,  2,   2,   4, 1,  0,  0,  "bridge head"},
{ '=', P_FOOD,   1, NAV_60, NPKG,  1,   1,   5, 1,  0,  0,  "bridge span"},
{ 'b', P_BAR,    2, 0,      BPKG,  2,   3,  10, 1,  0,  0,  "bank"},
{ '%', P_PETROL, 2, 0,      NPKG,  2,   2,   2, 1,  0,  0,  "refinery"},
{ 'e', 0,        2, 0,      NPKG,  2,   3,   7, 1,  0,  0,  "enlistment center"},
{ '?', 0,      500, 0,      0,     0,   0,   0, 1,  0,  0,  "unknown"},
{ 0,   0,        0, 0,      0,     0,   0,   0, 1,  0,  0,  0},
};

bool UpdateSectorDes (Sector sct, char des, bool flag)
{
    sct -> des = des;
}

void AddCountry (int n, char *name) { } 
