/*
 * $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/csync/RCS/nuke.c,v 1.3 1996/07/19 08:24:25 jpo Exp $
 *
 * $Log: nuke.c,v $
 * Revision 1.3  1996/07/19 08:24:25  jpo
 * Attempt to store nuke details - still needs testing
 *
 * Revision 1.2  1996/07/17 06:59:49  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "nuke.h"
#include "sector.h"

struct j_nuke {
    int x, y;
    int owner;
    int uid;
    int number;
    char *type;
} j_nuke;

extern struct s_nuketype nuke_type[];
extern int csync_debug;

static void *nuke_class_key (void *key) 
{
    int i;
    struct s_nuketype *nbase = key;

    if (nbase -> name == NULL) return NULL;
    for (i = 0; i < MAX_NUKETYPES; i++) {
	if (nuke_type[i].name == 0 ||
	    strcasecmp(nuke_type[i].name, nbase->name) == 0)
	    break;
    }
    return &nuke_type[i];
}


static Mapping nk_obj[] = {
    {"owner", 1, EDB_INT, offsetof(struct j_nuke, owner) },
    {"uid", 1, EDB_INT, offsetof(struct j_nuke, uid) },
    {"xloc", 1, EDB_INT, offsetof(struct j_nuke, x) },
    {"yloc", 1, EDB_INT, offsetof(struct j_nuke, y) },
    {"number", 1, EDB_INT, offsetof(struct j_nuke, number) },
    {"types", 15, EDB_CHAR, offsetof(struct j_nuke, type) },
    { NULL }
};

static Mapping nk_class[] = {
    {"name", 1, EDB_STRING, offsetof (struct s_nuketype, name) },
    {"lcm", 1, EDB_INT, offsetof (struct s_nuketype, lcm) },
    {"hcm", 1, EDB_INT, offsetof (struct s_nuketype, hcm) },
    {"oil", 1, EDB_INT, offsetof (struct s_nuketype, oil) },
    {"rad", 1, EDB_INT, offsetof (struct s_nuketype, rad) },
    {"blast", 1, EDB_INT, offsetof (struct s_nuketype, blst) },
    {"dam", 1, EDB_INT, offsetof (struct s_nuketype, dam) },
    {"cost", 1, EDB_INT, offsetof (struct s_nuketype, cost) },
    {"tech", 1, EDB_INT, offsetof (struct s_nuketype, tech) },
    {"weight", 1, EDB_INT, offsetof(struct s_nuketype, lbs) },
    {"flags", 1, EDB_LONG, offsetof(struct s_nuketype, abil) },
    { NULL }
};


static void *nuke_obj_key (void *key)
{
    bzero ((char *)&j_nuke, sizeof (j_nuke));
    return &j_nuke;
}

static void nuke_obj_final (ptr)
void *ptr;
{
    struct j_nuke *np = (struct j_nuke *)ptr;
    int i;
    Sector sct;
    Stockp stockp;
    int nuke_type;

    sct = World(np -> x, np -> y, S_EXIST);
    if (sct == NULL)
	return;
    stockp = s_stock(sct);
    if (stockp == NULL) {
	stockp = NewStockPile ();
    }
    set_sp_x (stockp, np -> x);
    set_sp_y (stockp, np -> y);
    set_sp_nr (stockp, np -> uid);
    set_sp_owner (stockp, np -> owner);
    set_stock(sct, stockp);
    set_nuk (sct, 0);
    for (i = 0; i < nr_nuke_types; i ++)
	    set_sp_nukamt (stockp, i, 0);
    nuke_type = FindNukeType (np -> type);
    if (nuke_type < 0) return;
    set_sp_nukamt (stockp, nuke_type, np -> number);
    add_nuk(sct, np -> number);
}

static void dump_nuke_class ()
{
    int i;
    for (i = 0; nuke_type[i].name != NULL; i++)
	printthing (&nuke_type[i], nk_class, "Nuke class");
}

static void dump_nuke_obj ()
{
    Nuke ptr;
    for (ptr = spl_head; ptr; ptr = sp_next(ptr))
	printthing (ptr, nk_obj, "Nuke object");
}


Name2Mapping nuke_obj_map =
{"nuke object", NUK_OBJECT, sizeof(struct j_nuke),
     nk_obj, nuke_obj_key, nuke_obj_final, dump_nuke_obj };

Name2Mapping nuke_class_map =
{"nuke class", NUK_CLASS, sizeof(struct s_nuketype), 
 nk_class, nuke_class_key, NULL, dump_nuke_class};
