/*
 * $Header: /nexor/users/jpo/xemp/xemp5.0/lib/csync/RCS/plane.c,v 1.2 1996/07/17 07:00:01 jpo Exp $
 *
 * $Log: plane.c,v $
 * Revision 1.2  1996/07/17 07:00:01  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "plane.h"
#include "sector.h"

extern struct s_pltype planetypes[];
extern int csync_debug;

static void *plane_class_key (void *key) 
{
    int i;
    struct s_pltype *pbase = key;

    for (i = 0; i < MAX_PLANETYPES; i++) {
	if (planetypes[i].nam == 0 ||
	    strcasecmp(planetypes[i].nam, pbase->nam) == 0)
	    break;
    }
    return &planetypes[i];
}


static Mapping pl_obj[] = {
    {"owner", 1, EDB_INT, offsetof(struct s_plane, own) },
    {"uid", 1, EDB_INT, offsetof(struct s_plane, nr) },
    {"xloc", 1, EDB_INT, offsetof(struct s_plane, x) },
    {"yloc", 1, EDB_INT, offsetof(struct s_plane, y) },
    {"type", 1, EDB_UCHAR, offsetof(struct s_plane, type) },
    {"effic", 1, EDB_CHAR, offsetof(struct s_plane, eff) },
    {"mobil", 1, EDB_INT, offsetof(struct s_plane, mob) },
/*    {"sell", 1, EDB_INT, offsetof(struct s_plane, mob) }, */
    {"tech", 1, EDB_INT, offsetof(struct s_plane, tech) },
/*    {"group", 1, EDB_INT, offsetof(struct s_plane, tech) }, */
/*    {"opx", 1, EDB_INT, offsetof(struct s_plane, tech) }, */
/*    {"opy", 1, EDB_INT, offsetof(struct s_plane, tech) }, */
    {"mission", 1, EDB_CHAR, offsetof(struct s_plane, mission) },
    {"wing", 1, EDB_CHAR, offsetof(struct s_plane, wing) },
    {"range", 1, EDB_UCHAR, offsetof(struct s_plane, range) },
    {"ship", 1, EDB_INT, offsetof(struct s_plane, shipnr) },
    {"att", 1, EDB_UCHAR, offsetof(struct s_plane, att) },
    {"def", 1, EDB_CHAR, offsetof(struct s_plane, def) },
    {"harden", 1, EDB_UCHAR, offsetof(struct s_plane, hard) },
    {"nuketype", 1, EDB_UCHAR, offsetof(struct s_plane, nuketype) },
    {"flags", 1, EDB_UCHAR, offsetof(struct s_plane, flags) },
    {"land", 1, EDB_INT, offsetof(struct s_plane, landnr) },
    { NULL }
};

static Mapping pl_class[] = {
    {"name", 1, EDB_STRING, offsetof (struct s_pltype, nam) },
    {"lcm", 1, EDB_INT, offsetof (struct s_pltype, lcm) },
    {"hcm", 1, EDB_INT, offsetof (struct s_pltype, hcm) },
    {"cost", 1, EDB_INT, offsetof (struct s_pltype, cost) },
    {"tech", 1, EDB_INT, offsetof (struct s_pltype, tech) },
    {"acc", 1, EDB_INT, offsetof (struct s_pltype, acc) },
    {"load", 1, EDB_INT, offsetof(struct s_pltype, load) },
    {"att", 1, EDB_INT, offsetof(struct s_pltype, att) },
    {"def", 1, EDB_INT, offsetof(struct s_pltype, def) },
    {"range", 1, EDB_INT, offsetof(struct s_pltype, range) },
    {"crew", 1, EDB_INT, offsetof(struct s_pltype, crew) },
    {"fuel", 1, EDB_INT, offsetof(struct s_pltype, fuel) },
    {"stealth", 1, EDB_INT, offsetof(struct s_pltype, stlth) },
    {"flags", 1, EDB_LONG, offsetof(struct s_pltype, flags) },
    { NULL }
};


static void *plane_obj_key (key)
void *key;
{
    Plane plane;
    Plane nplane = (Plane)key;

    plane = NrToPlane (pl_nr(nplane));
    if (plane == NULL) {
	plane = (Plane) calloc (1, sizeof *plane);
	*plane = *nplane;
	AddPlaneToList(plane);
	return plane;
    } 
    DeletePlaneFromSector (plane);
    return plane;
}

static void plane_obj_final (ptr)
void *ptr;
{
    Plane plane = (Plane)ptr;

    clr_pl_marked (plane);
    AddPlaneToSector (plane, World(pl_xcd(plane), pl_ycd(plane), S_DESIG));
    return;
}

static void dump_plane_class ()
{
    int i;
    for (i = 0; planetypes[i].nam != NULL; i++)
	printthing (&planetypes[i], pl_class, "Plane class");
}

static void dump_plane_obj ()
{
    Plane ptr;
    for ALL_PLANES(ptr)
	printthing (ptr, pl_obj, "Plane object");
}


Name2Mapping plane_obj_map =
{"plane object", PLN_OBJECT, sizeof(struct s_plane),
 pl_obj, plane_obj_key, plane_obj_final, dump_plane_obj };

Name2Mapping plane_class_map =
{"plane class", PLN_CLASS, sizeof(struct s_pltype), 
 pl_class, plane_class_key, NULL, dump_plane_class};
