/*
 * $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/csync/RCS/sector.c,v 1.3 1996/07/19 08:24:57 jpo Exp $
 *
 * $Log: sector.c,v $
 * Revision 1.3  1996/07/19 08:24:57  jpo
 * Track cost
 * allow more sector references.
 *
 * Revision 1.2  1996/07/17 07:00:23  jpo
 * New format table
 *
 */

#include "toolkit.h"
#include "jsync.h"
#include "main.h"
#include "var.h"
#include "sector.h"

extern struct dchrstr dchr[];

struct j_sector {
    uchar owner;
    short x, y;
    uchar des;
    uchar effic;
    short mobil;
    uchar terr;
    uchar work;
    uchar coastal;
    uchar newdes;
    uchar min;
    uchar gold;
    uchar fert;
    uchar ocon;
    uchar uran;
    uchar oldown;
    uchar off;
    short xdist;
    short ydist;
    ushort avail;
    ushort civil;
    ushort milit;
    ushort shell;
    ushort gun;
    ushort petrol;
    ushort iron;
    ushort dust;
    ushort bar;
    ushort food;
    ushort oil;
    ushort lcm;
    ushort hcm;
    ushort uw;
    ushort rad;
    ushort c_dist;
    ushort m_dist;
    ushort u_dist;
    ushort s_dist;
    ushort g_dist;
    ushort p_dist;
    ushort i_dist;
    ushort d_dist;
    ushort b_dist;
    ushort f_dist;
    ushort o_dist;
    ushort l_dist;
    ushort h_dist;
    ushort r_dist;
    ushort c_del;
    ushort m_del;
    ushort u_del;
    ushort s_del;
    ushort g_del;
    ushort p_del;
    ushort i_del;
    ushort d_del;
    ushort b_del;
    ushort f_del;
    ushort o_del;
    ushort l_del;
    ushort h_del;
    ushort r_del;
};

static struct j_sector jsect;

static void *sect_obj_key (key)
void *key;
{
    struct j_sector *jsp = (struct j_sector *)key;
    Sector sct;

    sct = World (jsp -> x, jsp -> y, S_DESIG);
    bzero ((char *)&jsect, sizeof jsect);
    jsect.x = s_xcd(sct);
    jsect.y = s_ycd(sct);
    jsect.owner = s_owner(sct);
    if (KNOW_DES(sct))
	jsect.des = DesigIndex(s_des(sct));
    else jsect.des = MAXCHAR;
    
    if (KNOW_OIL(sct))
	jsect.ocon = s_oil(sct);
    else jsect.ocon = MAXCHAR;
    if (KNOW_FER(sct))
	jsect.fert = s_fer(sct);
    else jsect.fert = MAXCHAR;

    /* part 2 */

    if (s_inf(sct) & (LOO|SPY|ALL))
	jsect.effic = s_eff(sct);
    else jsect.effic = MAXCHAR;
    if (KNOW_ALL(sct)) {
	jsect.mobil = s_mob(sct);
	jsect.off = s_off(sct);
    }
    else {
	jsect.mobil = -1;
	jsect.off = MAXCHAR;
    }
    if (KNOW_RES(sct)) {
	jsect.min = s_min(sct); 
	jsect.gold = s_gol(sct);
	jsect.uran = s_ura(sct);
    }
    else {
	jsect.min = MAXCHAR;
	jsect.gold = MAXCHAR;
	jsect.uran = MAXCHAR;
    }
    if (KNOW_CIV(sct))
	jsect.civil = s_civ(sct);
    else
	jsect.civil = MAXSHORT;
    if (KNOW_MIL(sct))
	jsect.milit = s_mil(sct);
    else jsect.milit = MAXSHORT;

    if (KNOW_ALL(sct)) {
	jsect.dust = q_dus(sct);
	jsect.bar = q_bar(sct);
	jsect.oil = q_oil(sct);
	jsect.lcm = q_lcm(sct);
	jsect.hcm = q_hcm(sct);
	jsect.uw = q_uw(sct);
	jsect.rad = q_rad(sct);
    }
    else {
	jsect.dust = MAXSHORT;
	jsect.bar = MAXSHORT;
	jsect.oil = MAXSHORT;
	jsect.lcm = MAXSHORT;
	jsect.hcm = MAXSHORT;
	jsect.uw = MAXSHORT;
	jsect.rad = MAXSHORT;
    }
    if (s_inf(sct) & (SPY|ALL)) {
	jsect.food = q_foo(sct);
	jsect.shell = q_she(sct);
	jsect.gun = q_gun(sct);
	jsect.petrol = q_pet(sct);
	jsect.iron = q_iro(sct);
    }
    else {
	jsect.food = MAXSHORT;
	jsect.shell = MAXSHORT;
	jsect.gun = MAXSHORT;
	jsect.petrol = MAXSHORT;
	jsect.iron = MAXSHORT;
    }

    /* part 3 */
    if (KNOW_ALL(sct)) {
	jsect.terr = s_ter(sct);
	jsect.work = s_wor(sct);
/*	jsect.coastal; */
	jsect.newdes = DesigIndex(s_nds(sct));
	if (jsect.newdes == 0)
	    jsect.newdes = MAXCHAR;
/*	jsect.oldown; */
	jsect.xdist = s_dxc(sct);
	jsect.ydist = s_dyc(sct);
	jsect.avail = s_ava(sct);
	jsect.c_dist = t_civ(sct);
	jsect.m_dist = t_mil(sct);
	jsect.u_dist = t_uw(sct);
	jsect.s_dist = t_she(sct);
	jsect.g_dist = t_gun(sct);
	jsect.p_dist = t_pet(sct);
	jsect.i_dist = t_iro(sct);
	jsect.d_dist = t_dus(sct);
	jsect.b_dist = t_bar(sct);
	jsect.f_dist = t_foo(sct);
	jsect.o_dist = t_oil(sct);
	jsect.l_dist = t_lcm(sct);
	jsect.h_dist = t_hcm(sct);
	jsect.r_dist = t_rad(sct);
#define cd_type(s, t) ((s) -> sct2 -> sct3 -> cut[(t)])
	jsect.c_del = cd_type(sct, D_CIV);
	jsect.m_del = cd_type(sct, D_MIL);
	jsect.u_del = cd_type(sct, D_UW);
	jsect.s_del = cd_type(sct, D_SHE);
	jsect.g_del = cd_type(sct, D_GUN);
	jsect.p_del = cd_type(sct, D_PET);
	jsect.i_del = cd_type(sct, D_IRO);
	jsect.d_del = cd_type(sct, D_DUS);
	jsect.b_del = cd_type(sct, D_BAR);
	jsect.f_del = cd_type(sct, D_FOO);
	jsect.o_del = cd_type(sct, D_OIL);
	jsect.l_del = cd_type(sct, D_LCM);
	jsect.h_del = cd_type(sct, D_HCM);
	jsect.r_del = cd_type(sct, D_RAD);
#undef cd_type
    }
    else {
	jsect.terr = MAXCHAR;
	jsect.work = MAXCHAR;
/*	jsect.coastal; */
	jsect.newdes = MAXCHAR;
/*	jsect.oldown; */
	jsect.xdist = MAXSHORT;
	jsect.ydist = MAXSHORT;
	jsect.avail = MAXSHORT;
	jsect.c_dist = MAXSHORT;
	jsect.m_dist = MAXSHORT;
	jsect.u_dist = MAXSHORT;
	jsect.s_dist = MAXSHORT;
	jsect.g_dist = MAXSHORT;
	jsect.p_dist = MAXSHORT;
	jsect.i_dist = MAXSHORT;
	jsect.d_dist = MAXSHORT;
	jsect.b_dist = MAXSHORT;
	jsect.f_dist = MAXSHORT;
	jsect.o_dist = MAXSHORT;
	jsect.l_dist = MAXSHORT;
	jsect.h_dist = MAXSHORT;
	jsect.r_dist = MAXSHORT;
	jsect.c_del = MAXSHORT;
	jsect.m_del = MAXSHORT;
	jsect.u_del = MAXSHORT;
	jsect.s_del = MAXSHORT;
	jsect.g_del = MAXSHORT;
	jsect.p_del = MAXSHORT;
	jsect.i_del = MAXSHORT;
	jsect.d_del = MAXSHORT;
	jsect.b_del = MAXSHORT;
	jsect.f_del = MAXSHORT;
	jsect.o_del = MAXSHORT;
	jsect.l_del = MAXSHORT;
	jsect.h_del = MAXSHORT;
	jsect.r_del = MAXSHORT;
    }
    return &jsect;
}

static void sect_finish (key)
void *key;
{
    struct j_sector *jsp = (struct j_sector *)key;
    Sector sct;

    sct = World (jsp -> x, jsp -> y, S_OWNED);
    set_owner(sct, jsp -> owner);
    if(jsp -> des < SCT_MAXDEF+4 && jsp -> des > 0) {
	SET_INFO_DES(sct);
	set_des(sct, dchr[jsp -> des].d_mnem);
    }
     
    if (jsp -> ocon != MAXCHAR) {
	set_oil(sct, jsp -> ocon);
	SET_INFO_OIL(sct);
    }
    
    if (jsp -> fert != MAXCHAR) {
	SET_INFO_FER(sct);
	set_fer(sct, jsp -> fert);
    }

    /* part 2 */

    if (jsp -> effic != MAXCHAR) {
	set_eff(sct, jsp -> effic);
	SET_INFO_SPY(sct);
    }
    if (jsp -> mobil != -1) {
	set_mob(sct, jsp->mobil);
	SET_INFO_ALL(sct);
    }
    if (jsp -> off != MAXCHAR) {
	set_off(sct, jsp -> off);
	SET_INFO_ALL(sct);
    }

#define upd(x,y) if (jsp -> x != MAXCHAR) \
    { y (sct, jsp -> x); SET_INFO_RES(sct); }
    upd(min, set_min);
    upd(gold, set_gol);
    upd(uran, set_ura);
#undef upd
    if (jsp -> civil != MAXSHORT) {
	set_civ(sct, jsp -> civil);
	SET_INFO_LOO(sct);
    }
    if (jsp -> milit != MAXSHORT) {
	set_mil(sct, jsp -> milit);
	SET_INFO_LOO(sct);
    }
    if (jsp -> dust != MAXSHORT) {
	set_q_dus(sct, jsp->dust);
	SET_INFO_ALL(sct);
    }
#define upd(x,y) if (jsp -> x != MAXSHORT) y (sct, jsp -> x)
    upd(bar, set_q_bar);
    upd(oil, set_q_oil);
    upd(lcm, set_q_lcm);
    upd(hcm, set_q_hcm);
    upd(uw, set_q_uw);
    upd(rad, set_q_rad);
    upd(food, set_q_foo);
    upd(shell, set_q_she);
    upd(gun, set_q_gun);
    upd(petrol, set_q_pet);
    upd(iron, set_q_iro);

    /* part 3 */
    if (jsp -> terr != MAXCHAR) {
	set_ter(sct, jsp -> terr);
	SET_INFO_ALL(sct);
    }
    if (jsp -> work != MAXCHAR) {
	set_wor(sct, jsp -> work);
	SET_INFO_ALL(sct);
    }
/*	jsect.coastal; */
    if (jsp -> newdes != MAXCHAR &&
	jsp -> newdes < SCT_MAXDEF+4 &&
	jsp -> newdes > 0) {
	set_nds(sct, dchr[jsp -> newdes].d_mnem);
	SET_INFO_ALL(sct);
    }
/*	jsect.oldown; */
    if(jsp -> xdist != MAXSHORT)
	set_dxc(sct, jsp -> xdist);
    if(jsp -> ydist != MAXSHORT)
	set_dyc(sct, jsp -> ydist);
    upd(avail, set_ava);
    upd(c_dist, set_t_civ);
    upd(m_dist, set_t_mil);
    upd(u_dist, set_t_uw);
    upd(g_dist, set_t_gun);
    upd(s_dist, set_t_she);
    upd(p_dist, set_t_pet);
    upd(i_dist, set_t_iro);
    upd(d_dist, set_t_dus);
    upd(f_dist, set_t_foo);
    upd(o_dist, set_t_oil);
    upd(l_dist, set_t_lcm);
    upd(h_dist, set_t_hcm);
    upd(r_dist, set_t_rad);
#undef upd
#define upd(x,y) if (jsp -> x != MAXSHORT) sct -> sct2 -> sct3 -> cut[y] = jsp -> x
    
    upd(c_del, D_CIV);
    upd(m_del, D_MIL);
    upd(u_del, D_UW);
    upd(s_del, D_SHE);
    upd(g_del, D_GUN);
    upd(p_del, D_PET);
    upd(i_del, D_IRO);
    upd(d_del, D_DUS);
    upd(b_del, D_BAR);
    upd(f_del, D_FOO);
    upd(o_del, D_OIL);
    upd(l_del, D_LCM);
    upd(h_del, D_HCM);
    upd(r_del, D_RAD);
#undef upd
    DrawSector (sct);
}

#define noffset(x) offsetof(struct j_sector, x)

static Mapping sect_obj[] = {
    { "owner", 1, EDB_UCHAR, noffset(owner) },
    { "xloc", 1, EDB_SHORT, noffset(x) },
    { "yloc", 1, EDB_SHORT, noffset(y) },
    { "des", 1, EDB_UCHAR, noffset(des) },
    { "effic", 1, EDB_UCHAR, noffset(effic) },
    { "mobil", 1, EDB_SHORT, noffset(mobil) },
    { "terr", 1, EDB_UCHAR, noffset(terr) },
    { "work", 1, EDB_UCHAR, noffset(work) },
    { "coastal", 1, EDB_UCHAR, noffset(coastal) },
    { "newdes", 1, EDB_UCHAR, noffset(newdes) },
    { "min", 1, EDB_UCHAR, noffset(min) },
    { "gold", 1, EDB_UCHAR, noffset(gold) },
    { "fert", 1, EDB_UCHAR, noffset(fert) },
    { "ocon", 1, EDB_UCHAR, noffset(ocon) },
    { "uran", 1, EDB_UCHAR, noffset(uran) },
    { "oldown", 1, EDB_UCHAR, noffset(oldown) },
    { "off", 1, EDB_UCHAR, noffset(off) },
    { "xdist", 1, EDB_SHORT, noffset(xdist) },
    { "ydist", 1, EDB_SHORT, noffset(ydist) },
    { "avail", 1, EDB_USHORT, noffset(avail) },
    { "civil", 1, EDB_USHORT, noffset(civil) },
    { "milit", 1, EDB_USHORT, noffset(milit) },
    { "shell", 1, EDB_USHORT, noffset(shell) },
    { "gun", 1, EDB_USHORT, noffset(gun) },
    { "petrol", 1, EDB_USHORT, noffset(petrol) },
    { "iron", 1, EDB_USHORT, noffset(iron) },
    { "dust", 1, EDB_USHORT, noffset(dust) },
    { "bar", 1, EDB_USHORT, noffset(bar) },
    { "food", 1, EDB_USHORT, noffset(food) },
    { "oil", 1, EDB_USHORT, noffset(oil) },
    { "lcm", 1, EDB_USHORT, noffset(lcm) },
    { "hcm", 1, EDB_USHORT, noffset(hcm) },
    { "uw", 1, EDB_USHORT, noffset(uw) },
    { "rad", 1, EDB_USHORT, noffset(rad) },
    { "c_dist", 1, EDB_USHORT, noffset(c_dist) },
    { "m_dist", 1, EDB_USHORT, noffset(m_dist) },
    { "u_dist", 1, EDB_USHORT, noffset(u_dist) },
    { "s_dist", 1, EDB_USHORT, noffset(s_dist) },
    { "g_dist", 1, EDB_USHORT, noffset(g_dist) },
    { "p_dist", 1, EDB_USHORT, noffset(p_dist) },
    { "i_dist", 1, EDB_USHORT, noffset(i_dist) },
    { "d_dist", 1, EDB_USHORT, noffset(d_dist) },
    { "b_dist", 1, EDB_USHORT, noffset(b_dist) },
    { "f_dist", 1, EDB_USHORT, noffset(f_dist) },
    { "o_dist", 1, EDB_USHORT, noffset(o_dist) },
    { "l_dist", 1, EDB_USHORT, noffset(l_dist) },
    { "h_dist", 1, EDB_USHORT, noffset(h_dist) },
    { "r_dist", 1, EDB_USHORT, noffset(r_dist) },
    { "c_del", 1, EDB_USHORT, noffset(c_del) },
    { "c_del", 1, EDB_USHORT, noffset(c_del) },
    { "m_del", 1, EDB_USHORT, noffset(m_del) },
    { "u_del", 1, EDB_USHORT, noffset(u_del) },
    { "s_del", 1, EDB_USHORT, noffset(s_del) },
    { "g_del", 1, EDB_USHORT, noffset(g_del) },
    { "p_del", 1, EDB_USHORT, noffset(p_del) },
    { "i_del", 1, EDB_USHORT, noffset(i_del) },
    { "d_del", 1, EDB_USHORT, noffset(d_del) },
    { "b_del", 1, EDB_USHORT, noffset(b_del) },
    { "f_del", 1, EDB_USHORT, noffset(f_del) },
    { "o_del", 1, EDB_USHORT, noffset(o_del) },
    { "l_del", 1, EDB_USHORT, noffset(l_del) },
    { "h_del", 1, EDB_USHORT, noffset(h_del) },
    { "r_del", 1, EDB_USHORT, noffset(r_del) },
    {NULL},
};
#undef noffset

static void dump_sector_obj ()
{
    int x, y;

    for (y = 0; y < MAX_Y; y++)
	for (x = 0; x < MAX_X; x++) {
	    Sector sct = World(x, y, S_EXIST);
	    if (sct)
		printf ("Sector %d,%d owner=%d, des=%c\n",
			s_xcd(sct), s_ycd(sct), s_owner(sct), s_des(sct));
	}
}

#define noffset(x) offsetof(struct dchrstr, x)

static Mapping sect_class[] = {
    { "mnem", 1, EDB_INT, noffset(d_mnem) },
    { "prd", 1, EDB_INT, noffset(d_prd) },
    { "mcst", 1, EDB_INT, noffset(d_mcst) },
    { "flg", 1, EDB_INT, noffset(d_flg) },
    { "pkg", 1, EDB_INT, noffset(d_pkg) },
    { "ostr", 1, EDB_INT, noffset(d_ostr) },
    { "dstr", 1, EDB_INT, noffset(d_dstr) },
    { "value", 1, EDB_INT, noffset(d_value) },
    { "cost", 1, EDB_INT, noffset(d_cost) },
    { "build", 1, EDB_INT, noffset(d_bld) },
    { "lcms", 1, EDB_INT, noffset(d_lcm) },
    { "hcms", 1, EDB_INT, noffset(d_hcm) },
    { "name", 1, EDB_STRING, noffset(d_name) },
    { NULL}
};

static void *sect_class_key(ptr)
void *ptr;
{
    struct dchrstr *dnew = (struct dchrstr *)ptr;
    struct dchrstr *dp;
    static char first = 1;

    if (first) {
	first = 0;
	for (dp = dchr; dp -> d_name; dp++)
	    dp -> d_name = strdup (dp -> d_name);
    }
    if (dnew -> d_mnem == '\0') return NULL;

    for (dp = dchr; dp -> d_name; dp++)
	if (dp -> d_mnem == dnew -> d_mnem)
	    break;
    return dp;
}

static void dump_sector_class() 
{
    struct dchrstr *dp;

    for (dp = dchr; dp -> d_name; dp++)
	printthing (dp, sect_class, "Sector class");
}

Name2Mapping sector_obj_map =
{"sector object", SCT_OBJECT, sizeof(struct j_sector),
 sect_obj, sect_obj_key, sect_finish, dump_sector_obj };


Name2Mapping sector_class_map = 
{"sector class", SCT_CLASS, sizeof(struct dchrstr),
 sect_class,  sect_class_key, NULL, dump_sector_class};
