/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/data/RCS/data.c,v 5.5 1996/07/17 07:45:24 jpo Exp $
    $Date: 1996/07/17 07:45:24 $
    $Author: jpo $
    $Id: data.c,v 5.5 1996/07/17 07:45:24 jpo Exp $
    $Locker:  $
    $Log: data.c,v $
    Revision 5.5  1996/07/17 07:45:24  jpo
    New more flexible save and restore scheme

    Revision 5.4  1996/03/29 09:55:45  jpo
    Lint fixups

    Revision 5.3  1995/09/12 07:40:35  jpo
    removed TC version

    Revision 5.2  1995/09/08 07:15:37  jpo
    const

 * Revision 5.1  93/03/14  16:46:44  etienne
 * *** empty log message ***
 * 
 * Revision 5.0  93/02/06  09:22:34  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:35:48  greyhelm
 * Added RCS headers - Karl Hagen
 *

*/
	/*
	 *	Empire Tool,	file: data.c		<900212>
	 *
	 *	RetrieveData ()
	 */

#include "type.h"
#include "main.h"
#include "xrc.h"
#include "sector.h"
#include "nation.h"
#include <sys/file.h>
#include <errno.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

bool save_data = False;
extern int capitol_x, capitol_y;

static const char *eodump = "END OF DUMP LIST";

static void RestoreScts (fp, bin_dump)
FILE *fp;
bool bin_dump;
{
	char buffer [BUFSIZ];
	Sector sct;
	int x, y, info;
	int nr;
	int mines;

	uchar des;
	int owner, fer, min, gol, ura, oil, eff, civ, mil;
	time_t infotime;

			/* info | x | y */

	if (fgets (buffer, BUFSIZ, fp) != (char *) 0)
	{
		if (sscanf (buffer, "capitol at %d,%d",
			    &capitol_x, &capitol_y) != 2) {
			Bell ();
			PrintAtEmpire ("Bad capitol info");
			PrintAtEmpire ("");
		}
	} else
		return;

	while (fgets (buffer, BUFSIZ, fp) != (char *) 0)
	{
		if (strncmp (buffer, eodump, 16) == 0)
			break;

		nr = sscanf (buffer,
     "%d %d %d %c %d %d %d %d %ld %d %d %d %d %d %d\n",
				& info, & x, & y,
				& des, & owner, & fer, & oil, & mines,
				& infotime, & min, & gol, & ura, & civ,
				& mil, & eff);

		if (! (nr == 15 ||
		       (nr == 8 && (info & (SPY | LOO | RES)) == 0)))
		{
			PrintAtEmpire ("Bad sector info in datafile");
			PrintAtEmpire (Fmt ("Skipping Line \"%s\"", buffer));
			PrintAtEmpire ("");
			fprintf (stderr, "Skipping Line \"%s\"", buffer);
			Bell ();
			continue;
		}

		if ((info & (ALL | KNEWALL)) != 0)
			sct = World (x, y, S_OWNED);
		else if ((info & (SPY | RES | LOO)) != 0)
			sct = World (x, y, S_RESOU);
		else
			sct = World (x, y, S_DESIG);

		s_inf (sct) = info;

			/* des | owner | fer | oil | time */

		set_des (sct, des);
		set_owner (sct, owner);
		set_fer (sct, fer);
		set_oil (sct, oil);
		set_mines (sct, mines);

		if ((info & (SPY | LOO | RES)) != 0)
		{
			/* min | gol | ura | civ | mil | eff */

			set_time (sct, infotime);
			set_min (sct, min);
			set_gol (sct, gol);
			set_ura (sct, ura);
			set_civ (sct, civ);
			set_mil (sct,  mil);
			set_eff (sct, eff);
		}

		if (KNOW_ALL (sct) && ! deity && ! bin_dump)
		{

		/* Don't assume sector is still ours, if it is it
		 * will be updated by dump
		 */
			DEL_INFO (sct);
			SET_INFO_KNEWALL (sct);
		} else if (KNOW_ALL (sct) && ! bin_dump)
			set_nds (sct, des);
	}
}

static void SaveScts (fp)
FILE *fp;
{
    int x, y;
    Sector sct;

    fprintf (fp, "capitol at %d,%d\n", capitol_x, capitol_y);

    for (x = 0; x < MAX_X; x ++) 
	for (y = 0; y < MAX_Y; y++)
	{
	    sct = World (x, y, S_EXIST);

	    if (sct != (Sector) 0)
	    {

		/* info | xcd | ycd | des | owner | fer | oil | mines | Time */

		fprintf (fp, "%hd %hd %hd %c %hd %hd %hd %hd",
			 s_inf (sct),
			 s_xcd (sct),
			 s_ycd (sct),
			 s_des (sct),
			 s_owner (sct),
			 s_fer (sct),
			 s_oil (sct),
			 s_mines (sct));

		if ((s_inf (sct) & (SPY | LOO | RES)) != 0)
		{
		    /* min | gol | ura | civ | mil | eff */

		    fprintf (fp, " %ld %hd %hd %hd %hd %hd %hd",
			     s_time (sct),
			     s_min (sct),
			     s_gol (sct),
			     s_ura (sct),
			     s_civ (sct),
			     s_mil (sct),
			     s_eff (sct));
		}

		fprintf (fp, "\n");
	    }
	}

    fprintf (fp, "%s\n", eodump);
}

static const char *eocsync = "END OF CSYNC";

static void RestoreCsyncDef (fp)
FILE *fp;
{
    char buf[4*BUFSIZ];

    while (fgets (buf, sizeof buf, fp) != NULL) {
	char *cp;
	if ((cp = index(buf, '\n')) != NULL)
	    *cp = '\0';
	if (strcmp (buf, eocsync) == 0)
	    break;
	edb_parse_c_sync (buf);
    }
}

static void SaveCsyncDef (fp)
FILE *fp;
{
    dump_object(fp);
    fprintf(fp, "%s\n", eocsync);
}

char *MakeDataFile (suffix)
const char *suffix;
{
	char *home;
	char *fname;
	char *lead;

	if ((home = getenv ("HOME")) == (char *) 0)
	{
		(void) fprintf (stderr, "HOME not set, leaving...\n");
		leave ();
	}

	if (xrc.savefile) {
		fname = xrc. savefile;
		lead = "";
	}
	else {
		fname = cname;
		lead = ".";
	}
		
	if (xrc. savedir) {
		if(xrc. savedir[0] == '/' ||
		   strncmp(xrc. savedir, "./", 2) == 0 ||
		   strncmp (xrc.savedir, "../", 3) == 0 ||
		   strcmp(xrc.savedir, ".") == 0)
			return Fmt ("%s/%s%s%s", xrc.savedir, lead,
				    fname, suffix);
		else 
			return Fmt ("%s/%s/%s%s%s", home, xrc.savedir, lead,
				    fname, suffix);
	}
	else
		return Fmt ("%s/%s%s%s", home, lead, fname, suffix);
}

struct dispatch {
    const char *t_name;
    void (*t_rfnx) _PROTO((FILE *fp));
    void (*t_sfnx) _PROTO((FILE *fp));
};


static const struct dispatch disptbl[] = {
    { "version", RestoreVersion, SaveVersion },
    { "bridge", RestoreBridgeData, SaveBridgeData },
    { "csync", RestoreCsyncDef, SaveCsyncDef },
    { "countries", RestoreCountries, SaveCountries },
    { "buffered", ReadBufCommands, SaveBufCommands },
    { "ferries", ReadFerries, SaveFerries },
    { "mail", RestoreMail, SaveMail },
    { "showship", RestoreShowShip, SaveShowShip },
    { "showland", RestoreShowLand, SaveShowLand },
    { "showplane", RestoreShowPlane, SaveShowPlane },
    { "highlight", ReadHighlight, SaveHighlight },
    { "nukeshow", LoadNukeShow, SaveNukeShow },
    { "plan", LoadPlanOptions, SavePlanOptions },
    { "item", ReadItems, SaveItems },
    { "products", ReadProducts, SaveProducts },
    { "desig", ReadDesignate, SaveDesignate },
    { "sectors", RestoreScts, SaveScts },
    { NULL},
};

bool RetrieveData (bin_dump)
bool bin_dump;
{
	FILE *fp;
	char *fname;
	char buf[BUFSIZ];
	const struct dispatch *tp;

	fname = MakeDataFile ("");

	if (xrc. compress) {
		Message ("Uncompressing datafile");
		system (Fmt ("%s %s > /dev/null 2>& 1", UNCOMP_BIN, fname));
	}

	if ((fp = fopen (fname, "r")) == (FILE *) 0)
	{
		PrintAtEmpire (Fmt ("No Datafile %s", fname));
		PrintAtEmpire ("");
		Bell ();
		(void) EmpireMore ();
		return False;
	}
	else if (access (fname, W_OK) != 0)
	{
		PrintAtEmpire (Fmt (
			"Warning can read but not write Datafile %s", fname));
		PrintAtEmpire ("");
		Bell ();
		(void) EmpireMore ();
		return False;
	}

		/* Read sectors */

	Message ("Restoring....");
	while (fgets(buf, sizeof buf, fp) != NULL) {
	    char *cp;
	    if (cp = index(buf, '\n'))
		*cp = '\0';
	    for (tp = disptbl; tp -> t_name; tp ++)
		if (strcmp(tp -> t_name, buf) == 0)
		    (*tp -> t_rfnx) (fp);
	    CheckRefreshEvents ();
	}

	if (ferror (fp)) {
		perror ("Error reading datafile ");
		fclose (fp);
		leave ();
	}

	fclose (fp);

	Message ("Restore done");
	return True;
}

void StoreData ()
{
    FILE *fp, *fopen ();
    char *fname;
    const struct dispatch *tp;
    extern char *sys_errlist[];

    if (command_state == FASTQUIT_STATE)
	return;

    if (command_state == STARTUP_STATE)
    {
	if (! xstarted)
	    return;

	if (! Confirm ("Aborted while collecting data, save data ?",
		       False))
	    return;
    }
    else if (command_state == TEST_STATE)
    {
	Error ("You can't save data when you're in a test state");
	return;
    }

    BinDumpAll ();

    fname = MakeDataFile ("");

    fp = fopen (fname, "w");

    if (fp == (FILE *) 0)
    {
	(void) fprintf (stderr, "Can't open %s !!!\n", fname);
	return;
    }

    /* Write sectors to remember */

    Message ("Saving data");
    for (tp = disptbl; tp -> t_name; tp ++) {
	fprintf (fp, "%s\n", tp -> t_name);
	(*tp->t_sfnx) (fp);
    }

    if (ferror (fp))
    {
	Message (Fmt ("Save data failed : %s", sys_errlist [errno]));
	fprintf (stderr, Fmt ("Save data failed : %s", sys_errlist [errno]));
    }

    fclose (fp);

    if (xrc. compress)
    {
	Message ("Compressing data");
	system (Fmt ("%s %s> /dev/null 2>& 1", COMP_BIN, fname));
    }

    Message ("Save data done");
}

void CheckDump ()
{
    int x, y;
    Sector sct;
    int nr = 0;

    for (x = 0; x < MAX_X; x++)
	for (y = 0; y < MAX_Y; y++)
	{
	    sct = World (x, y, S_EXIST);

	    if (sct == (Sector) 0)
		continue;

	    if (KNEW_ALL (sct))
	    {
		nr++;
		PrintAtEmpire (Fmt ("Sector %s has been lost !!",
				    CrdStr (sct)));

		set_owner (sct, UNKNOWN_CNUM);

		DEL_INFO (sct);
		SET_INFO_RES (sct);
	    }
	}

    if (nr)
    {
	Bell ();
	(void) EmpireMore ();
	PrintAtEmpire ("");
    }
}
