/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/nuke/RCS/show.c,v 5.3 1996/04/29 13:03:37 jpo Exp $
    $Date: 1996/04/29 13:03:37 $
    $Author: jpo $
    $Id: show.c,v 5.3 1996/04/29 13:03:37 jpo Exp $
    $Locker:  $
    $Log: show.c,v $
    Revision 5.3  1996/04/29 13:03:37  jpo
    Add show CB stuff

    Revision 5.2  1996/01/29 08:24:54  jpo
    New menu stuff

    Revision 5.1  1993/03/14 16:50:20  etienne
    *** empty log message ***

 * Revision 5.0  93/02/06  09:22:49  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:40:08  greyhelm
 * Added RCS headers - Karl Hagen
 *

*/
#include "main.h"
#include "sector.h"
#include "nation.h"
#include "nuke.h"

int SelectNukeType (x, y, task)
int x, y, task;
{
	Strings strings;
	char * head = NULL;
	bool add;
	int found;
	int i;

	found = 0;
	strings = InitStrings ();
	for (i = 0; i < nr_nuke_types; i ++)
	{
		add = False;

		switch (task)
		{

		case NK_BUILD:
			add = nt_tech (i) <= (int) n_tech (nation);
			break;
		}

		if (add)
		{
			if (found == 0)
				if (land_units) {
					AddStringID (strings,
				  	"Nuketype     lcm hcm oil rad ava tech res cost",
				  	-1);
				} else {
					AddStringID (strings,
				  	"Nuketype     lcm hcm oil rad ava tech cost",
				  	-1);
				}
			      if (land_units) {
				AddStringID (strings,
				Fmt ("%-12s %-3d %-3d %-3d %-3d %-3d %-4d %-4d $%d",
					nt_name (i),
					nt_lcm (i), nt_hcm (i), nt_oil (i),
					nt_rad (i), nt_ava (i), nt_tech (i),
					nt_res (i), nt_cost (i)),
				i);
			      } else {
				AddStringID (strings,
				Fmt ("%-12s %-3d %-3d %-3d %-3d %-3d %-4d $%d",
					nt_name (i),
					nt_lcm (i), nt_hcm (i), nt_oil (i),
					nt_rad (i), nt_ava (i), nt_tech (i),
					nt_cost (i)),
				i);
			      }
			found ++;
		}
	}

	if (found == 0)
	{
		switch (task)
		{

		case NK_BUILD:
			Message ("You can't build nukes (yet)");
			Bell ();
			return -1;
		}
	}

	switch (task)
	{

	case NK_BUILD:
		head = "Build which nuke?";
		break;
	}

	i = ChooseMenu (strings, head, map_win, x, y, NULL);
	FreeStrings (strings);

	return i;
}

int SelectNuke(x, y, stockp)
Stockp stockp;
int x, y;
{
	register int i, k;
	Strings strings;
	char * head;
	int quant, ntype[MAX_NUKETYPES];

	strings = InitStrings ();
	AddStringID (strings, "Nuketype     Quantity", -1);

	k = 0;
	for (i = 0; i < nr_nuke_types; i ++)
	{
		quant = sp_nukamt(stockp,i);
		if (quant != 0) 
		{
			AddStringID (strings, Fmt ("%-12s   %-3d", nt_name (i),
					quant), k);
			ntype[k] = i;
			k++;
		}
	}

	head = "Arm with which nuke?";

	i = ChooseMenu (strings, head, map_win, x, y, NULL);
	FreeStrings (strings);

	return i < 0 ? i : ntype[i];
}

const char *NukeCapNames (flags)
int flags;
{
	static char buffer [100];

	buffer [0] = '\0';

	if (BIT_SET(flags, NK_NEUTRON))
	    strcat (buffer, " neutron");
	return buffer;
}

static void ShowNukeCBStrings (strings)
Strings strings;
{
    int i;

    AddString (strings,
	       Fmt("%-12s %-3s %-3s %-3s %-3s %-3s %-4s %-4s %-6s %-4s %-4s %-4s %s",
		   "Nuketype", "lcm", "hcm", "oil", "rad", "ava", "tech",
		   land_units ? "res" : "---", "cost",
		   "blst", "dam", "lbs", "flags"));
    AddString (strings, "");

    for (i = 0; i < nr_nuke_types; i++) {
	AddString (strings,
		   Fmt ("%-12s %-3d %-3d %-3d %-3d %-3d %-4d %-4s $%-5d %-4d %-4d %-4d %s",
			nt_name (i),
			nt_lcm (i), nt_hcm (i), nt_oil (i),
			nt_rad (i), nt_ava (i), nt_tech (i),
			land_units ? Fmt("%-3d", nt_res (i)) : "-",
			nt_cost (i),
			nt_blst(i), nt_dam(i), nt_lbs(i),
			NukeCapNames (nt_abils(i))));
    }
}

void PageShowNukeCBs ()
{
    Strings strings;

    strings = InitStrings ();
    ShowNukeCBStrings (strings);

    if (StringsSize (strings) <= 2) {
	Message ("You don't know about nukes");
	FreeStrings (strings);
	return;
    }
    ShowStringsInPager (strings, "show nuke c&b");
}

