/*
    $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/lib/ship/RCS/select.c,v 5.5 1996/04/18 07:01:23 jpo Exp $
    $Date: 1996/04/18 07:01:23 $
    $Author: jpo $
    $Id: select.c,v 5.5 1996/04/18 07:01:23 jpo Exp $
    $Locker:  $
    $Log: select.c,v $
    Revision 5.5  1996/04/18 07:01:23  jpo
    rearrange a little

    Revision 5.4  1996/03/29 10:01:06  jpo
    Lint fixups

    Revision 5.3  1996/01/29 08:32:59  jpo
    New selection stuff

    Revision 5.2  1995/09/08 07:43:49  jpo
    const

    Revision 5.1  1993/03/14 16:51:39  etienne
    *** empty log message ***

 * Revision 5.0  93/02/06  09:23:42  greyhelm
 * Fixed backward compatabilty with Merc/KSU
 * Changed MOTD to show new version and authors
 * 
 * Revision 4.4  1993/02/06  04:43:25  greyhelm
 * Added RCS headers - Karl Hagen
 *

*/
#include "type.h"
#include "main.h"
#include "var.h"
#include "ship.h"
#include "sector.h"
#include "func.h"
#include "nation.h"

char * SelectShips (x, y, shtask, quest)
int x, y;
ShTask shtask;
const char * quest;
{
	extern int last_layout;

	static char buffer [200];

	Strings strings;
	Ship ptr;
	bool first;
	int nr = -1;

	strings = InitStrings ();
	AddStringID (strings,
		     Fmt ("%-4s %-16s %2s %3s  %3s %3s %3s %3s %4s",
			  "Ship", "", "Fl", "Eff", "Mob", "Civ",
			  "Mil", "Foo", "Tec"), -2);

	for (ptr = s_fship (cursct); ptr != (Ship) 0; ptr = sh_nxtsct (ptr))
	{
		if (! sh_owned (ptr))
			continue;

		switch (shtask) {
		case ST_NAVIGATE:
		    if (sh_mob (ptr) <= 0)
			continue;
		    break;
		case ST_UPGRADE:
		    if (sh_tech (ptr) == (int) n_tech (nation))
			continue;
		    break;

		case ST_TEND:
		    if (ptr == curship)
			continue;
		    break;

		case ST_LOADXPLANE:
		    if (sh_xpln (ptr) <= shiptypes [sh_type (ptr)] .xpl)
			continue;
		    break;

		case ST_LOADPLANE:
		    if (sh_pln (ptr) == shiptypes [sh_type (ptr)]. pla)
			continue;
		    break;

		case ST_LOADHELI:
		    if (sh_heli (ptr) == shiptypes [sh_type (ptr)]. hel)
			continue;
		    break;
		case ST_LOADLAND:
		    if (!shiptypes [sh_type (ptr)]. land &&
			(sh_land (ptr) == shiptypes [sh_type (ptr)] .land))
			continue;
		    break;
		case ST_LOADFUEL:
		    if (sh_oil (ptr) <= 0 && sh_pet (ptr) <= 0)
			continue;
		    break;
		case ST_ORDERS:
		case ST_SCRAP:
		case ST_FLEETADD:
		    break;
		}


		AddStringID (strings, Fmt (
			"%-4d %-16.16s  %c %-3d%% %-3d %-3d %-3d %-3d %-4d",
				sh_nr (ptr),
				ShipName (ptr),
				sh_fleet (ptr),
				sh_eff (ptr),
				sh_mob (ptr),
				sh_civ (ptr),
				sh_mil (ptr),
				sh_foo (ptr),
				sh_tech (ptr)),
			sh_nr (ptr));

		nr = sh_nr (ptr);
	}

	if (StringsSize (strings) == 1)
	{
		FreeStrings (strings);
		Message ("No available ships.");
		Bell ();
		return (char *) 0;
	}
	else if (StringsSize (strings) == 2)
	{
		FreeStrings (strings);
		return Fmt ("%d", nr);
	}

	if (last_layout == SHIP_MODE)
		SetStringFlag (strings, sh_nr (curship), True);
	else if (last_layout == FLEET_MODE)
		for (ptr = s_fship (cursct); ptr != (Ship) 0;
							ptr = sh_nxtsct (ptr))
			if (sh_fleet (ptr) == curfleet)
				SetStringFlag (strings, sh_nr (ptr), True);

	switch (MultiSelectPager (strings, quest, NULL, NOFUNC, NULL)) {
	case CANCELFUNC:
	default:
	    FreeStrings (strings);
	    return (char *)0;
	case DONEFUNC:
	    break;
	}
	InitStringList (strings);
	buffer [0] = '\0';
	first = True;
	while ((nr = GetNextSelectedId (strings)) != -1)
	{
	    if (nr == -2)
		continue;
	    if (first)
		first = False;
	    else
		strcat (buffer, "/");

	    strcat (buffer, Fmt ("%d", nr));
	}

	FreeStrings (strings);
	if (first)
	{
	    Message ("No ships selected");
	    return (char *) 0;
	}
	else
	    return buffer;
}
