/*
 * $Header: /a/victor/nexor/user4/jpo/xemp/xemp5.0/xm/RCS/xmenu.c,v 1.1 1996/04/29 13:03:48 jpo Exp jpo $
 * $Date: 1996/04/29 13:03:48 $
 * $Author: jpo $
 * $Id: xmenu.c,v 1.1 1996/04/29 13:03:48 jpo Exp jpo $
 * $Locker: jpo $
 * $Log: xmenu.c,v $
 * Revision 1.1  1996/04/29 13:03:48  jpo
 * Initial revision
 *
 *
 */

/* MOTIF variant of xemp */

#include "type.h"
#include "main.h"
#include "xemp.h"
#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/PushB.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>


static void DoCall_cb (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    void (*proc)() = client_data;

    (*proc) ();
}

struct menuitems {
    const char *str;
    void (*proc)();
};

static struct menuitems FileMenuItems[] = {
{	"About...", ShowVersion },
{	"Save",	StoreData },
{	"-",	NULL },
{	"Quit (and save)", DoQuit },
{	"Exit (no save)",  FastQuit },
{ NULL }
};

extern void ShowProduct (), ShowItems (), ShowDesignations();

static struct menuitems InfoMenuItems[] = {
    { "Nation", ShowNation },
    { "Power", DisplayPower },
    { "Budget", DoBudget },
    { "-", NULL },
    { "Ship Info", PageShowShipCBs },
    { "Plane Info", PageShowPlaneCBs },
    { "Land Info", PageShowLandCSBs },
    { "Nuke Info", PageShowNukeCBs },
    { "Product Info", ShowProduct },
    { "Item Info", ShowItems },
    { "Desig Show", ShowDesignations },
    { NULL },
};

static struct menuitems CommunicationsItems[] = {
    { "read telegrams",	BindRead },
    { "reread telegrams", BindReRead},
    { "send telegram",	BindSend },
    { "-", NULL},
    { "news",		News },
    { "headlines",	ShowHeadLines },
    { "-", NULL },
    { "announce",	Announce },
    { NULL },
};


static Widget create_list_menu (parent, name, list)
Widget parent;
char *name;
struct menuitems *list;
{
    Widget menu, item;
    struct menuitems *mp;

    menu = XmCreatePulldownMenu (parent, name, NULL, 0);
    for (mp = list; mp -> str; mp ++) {
	if (mp -> proc == NULL) {
	    item = XtVaCreateManagedWidget (mp -> str,
					    xmSeparatorWidgetClass,
					    menu,
					    NULL);
	}
	else {
	    item = XtVaCreateManagedWidget (mp -> str,
					    xmPushButtonWidgetClass,
					    menu,
					    NULL);
	    XtAddCallback (item, XmNactivateCallback, DoCall_cb, mp -> proc);
	}
    }

    return menu;
}

static void Raise_cb (w, client_data, call_data)
Widget w;
XtPointer client_data;
XtPointer call_data;
{
    WinInfo *win = (WinInfo *)client_data;
    RaiseWindow (*win);
}

static Widget create_window_menu (parent)
Widget parent;
{
    Widget menu, item;

    menu = XmCreatePulldownMenu (parent, "Windows", NULL, 0);

    item = XtVaCreateManagedWidget ("Census",
				    xmPushButtonWidgetClass,
				    menu,
				    NULL);
    XtAddCallback (item, XmNactivateCallback, Raise_cb, &census_win);

    return menu;
}

void CreateXMenubar (mbar, parent)
Widget mbar;
Widget parent;
{
    Widget menu;

    menu = create_list_menu (parent, "File", FileMenuItems);

    XtVaCreateManagedWidget ("File",
			     xmCascadeButtonWidgetClass,
			     mbar,
			     XmNsubMenuId, menu,
			     NULL);
    menu = create_list_menu (parent, "Info", InfoMenuItems);
    XtVaCreateManagedWidget ("Info",
			     xmCascadeButtonWidgetClass,
			     mbar,
			     XmNsubMenuId, menu,
			     NULL);
    menu = create_list_menu (parent, "Comms", CommunicationsItems);
    XtVaCreateManagedWidget ("Comms",
			     xmCascadeButtonWidgetClass,
			     mbar,
			     XmNsubMenuId, menu,
			     NULL);
    menu = create_window_menu (parent);
    XtVaCreateManagedWidget ("Windows",
			     xmCascadeButtonWidgetClass,
			     mbar,
			     XmNsubMenuId, menu,
			     NULL);
}

